import java.net.*;
import java.io.*;

public class MainServer {
	
	public static void main(String[] args) {
		MyTools tool=new MyTools();
		MyMonitoredTools monitored_tool=new MyMonitoredTools();
		ThreadRecServer thread_rs=new ThreadRecServer(tool,monitored_tool);
		thread_rs.start();
		String serv_1;
		String serv_2;
		try {
			FileInputStream ring=new FileInputStream("ring.txt");
			byte[] buf=new byte[30]; //buffer per leggere con una sola read i nomi degli altri 2 nodi
			int letti=ring.read(buf);
			String str=new String(buf);
			int mark=str.indexOf("\n");
			serv_1=new String(str.substring(0,mark-1));
			serv_2=new String(str.substring(mark+1,letti-2)); //rem: okkio al NEWLINE  DEI FILE !!!
			ring.close();
			FileInputStream newline=new FileInputStream("newline.txt");
			byte[] new_line=new byte[2];
			newline.read(new_line);
			newline.close();
			ThreadRecClient thread_rc=new ThreadRecClient(tool,monitored_tool,serv_1,serv_2,new String(new_line));
			thread_rc.start();
			
			Thread.sleep(20000);	//per dare il tempo agli altri server di lanciare i ThreadRecServer
			Socket sock_rich_1=null;
			Socket sock_rich_2=null;
			sock_rich_1=tool.connetti_server_rem(serv_1); //non fallisce grazie alla sleep sopra
			sock_rich_2=tool.connetti_server_rem(serv_2);
			ServerSocket sock_cleaner=new ServerSocket(7000);
			Socket sock_clean_1=null;
			Socket sock_clean_2=null;
			if (serv_1.compareTo(serv_2)>0) {	//in un ring di 3 server ce n'e' 1 solo che avvera sta condizione
				Thread.sleep(10000);	//per dare il tempo agli altri server di fare la accept (vedi sotto i Following Cleaner)
				System.out.println("Lancio InitialCleaner");
				sock_clean_1=tool.connetti_cleaner(serv_1);	//non fallisce grazie alla sleep che la precede
				sock_clean_2=sock_cleaner.accept();
				ThreadInitialCleaner thread_ic=new ThreadInitialCleaner(tool,monitored_tool,sock_rich_1,sock_rich_2,sock_clean_1,sock_clean_2);
				thread_ic.start();
				}
			else {
				System.out.println("Lancio FollowingCleaner");
				sock_clean_2=sock_cleaner.accept();
				sock_clean_1=tool.connetti_cleaner(serv_1);
				ThreadFollowingCleaner thread_fc=new ThreadFollowingCleaner(tool,monitored_tool,sock_rich_1,sock_rich_2,sock_clean_1,sock_clean_2);
				thread_fc.start();
				}
			}//try
		catch (InterruptedException e1) {
			System.out.println(e1);
			}
		catch (IOException e2) {
			System.out.println(e2);
			}
	}//main
}//class
