import java.net.*;
import java.io.*;

public class MyMonitoredTools {

boolean busy=false; //variabile condizione
boolean cleaner=false;

	public synchronized void fileToSock(String nome,Socket sock) {
		try {
			while (busy==true)
				wait();
			busy=true;	//comincia la SEZIONE CRITICA
			FileInputStream fin=new FileInputStream(nome);
			DataOutputStream bw=new DataOutputStream(sock.getOutputStream());
			for(;;) {
				byte[] buf=new byte[512];
				int letti=fin.read(buf);
				if (letti==-1) {
					bw.write('#');		//mark finale
					break;
					}
				bw.write(buf,0,letti);
				}//for
			bw.flush();
// prova a fare la close del buffer della socket!
			fin.close();
			busy=false;	//fine SEZIONE CRITICA
			notifyAll();
			}//try
		catch (InterruptedException e1) {
			System.out.println(e1);
			}
		catch (IOException e2) {
			System.out.println(e2);
			}
	}//fileToSock
	
	public synchronized String[] fileToArray(String nome) {
		try {
			while (busy==true && cleaner==false)
				wait();
			busy=true;	//comincia la SEZIONE CRITICA
			int count=0;
			String[] array=new String[100];  //HP server max le 100 canzoni per data composiz
			FileInputStream fin=new FileInputStream(nome);
			byte[] buf=new byte[512];			//HP tutti i titoli terminano con un '\n'
			int lung_assol=0; int lung_rel=0;
			for (;;) {
				int letti=fin.read(buf);  		 //leggo uno stream di titoli sul buffer
				if (letti==-1) break;
				for (lung_assol=0,lung_rel=0;lung_assol<letti;lung_assol++,lung_rel++) {
					if (buf[lung_assol]=='\n'){ //isolo un titolo nel buffer
						String str=new String(buf);
						array[count]=new String(str.substring(lung_assol-lung_rel,lung_assol+1));
						lung_rel=-1;								//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ guarda il metodo
						count++;										//sockToArray in class MyTools!!!
						}
					}//for interno
				}//for esterno
			array[count]="#"; //mark finale
			fin.close();
			busy=false;	//fine SEZIONE CRITICA
			notifyAll();
			if (count>0) return array;
			else return null;
			}//try
		catch (InterruptedException e1) {
			System.out.println(e1);
			return null;
			}
		catch (IOException e2) {
			System.out.println(e2);
			return null;
			}
	}//fileToArray

	public synchronized int conta_new_line(String nome) {
		try {
			while (busy==true)
				wait();
			busy=true;	//comincia la SEZIONE CRITICA
			FileInputStream fin=new FileInputStream(nome);
			int count=0;
			int quanti=fin.available();
			char car;
			for (int i=0;i<quanti;i++)
				if (fin.read()=='\n') count++;
			fin.close();
			busy=false;	//fine SEZIONE CRITICA
			notifyAll();
			return count;
			}//try
		catch (InterruptedException e1) {
			System.out.println(e1);
			return 0;
			}
		catch (IOException e2) {
			System.out.println(e2);
			return 0;
			}
	}//conta_new_line
	
	public synchronized void aggiungi_lista_server(String nomefile,String new_titolo) {
		try {								//new_titolo ha il "\n" da 2 bytes, quello dei file
			while (busy==true)
				wait();
			busy=true;	//comincia la SEZIONE CRITICA
			FileInputStream fin=new FileInputStream(nomefile);
			FileOutputStream fout=new FileOutputStream("appoggio.txt");
			byte[] car=new byte[1];
			int letti;
			boolean ispresent=false;
			for (;;) {		//scorre la lista da aggiornare
				letti=fin.read(car); 								//Comincia un nuovo titolo
				if (letti==-1) break;
				String titolo=new String(car);
				while (car[0]!='\n') {      						//Costruisce il titolo corrente
					fin.read(car);
					titolo=titolo+new String(car);
					}
				if (titolo.equals(new_titolo)) {					//Non inserire new_titolo, c' gi!
					fout.write(titolo.getBytes());
					ispresent=true;
					break;
					}
				else if (titolo.compareTo(new_titolo)>0) {	//Inserire ora il new_titolo
					fout.write(new_titolo.getBytes());
					fout.write(titolo.getBytes());
					break; 
					}
				else fout.write(titolo.getBytes());				//Ancora non si sa, ripeti il ciclo
				}//for
			if (!ispresent && letti==-1)
				fout.write(new_titolo.getBytes()); //Scrive ora la nuova e finisce
			else for (;;) {
				letti=fin.read(car);		//Dopo l'eventuale inserimento di new_titolo,
				if (letti==-1) break;	//completa il file appoggio, se necessario.
				fout.write(car);
				}
			fin.close();
			fout.close();
			File old_file=new File("lista_server.txt");
		 	old_file.delete();
		 	File new_file=new File("appoggio.txt");
	 		new_file.renameTo(new File("lista_server.txt"));
			busy=false;	//fine SEZIONE CRITICA
			notifyAll();
			}//try
		catch (InterruptedException e1) {
			System.out.println(e1);
			}
		catch (IOException e2) {
			System.out.println(e2);
			}
	}//aggiungi_lista_server				

	public synchronized void clean_lista_server(String[] lista_rem_1,String[] lista_rem_2) {
		try {	//REM le liste vengono dai FILES, NEWLINE DI 2 BYTE!!!
			while (busy==true)	//inoltre LE LISTE SERVER SONO SEMPRE ORDINATE!
				wait();
			busy=true;	//comincia la SEZIONE CRITICA
			cleaner=true;
			String[] lista_server=new String[100];
			lista_server=fileToArray("lista_server.txt");
			int n_songs=conta_nStrings(lista_server);
			int n_songs_rem_1=conta_nStrings(lista_rem_1);
			int n_songs_rem_2=conta_nStrings(lista_rem_2);
			int i=0; int j=0; int k=0;
			boolean deleted=false;
			FileOutputStream temp=new FileOutputStream("temp.txt");
			for (;i<n_songs;i++) { //scorro lista_server
				while ( j<n_songs_rem_1 && lista_server[i].compareTo(lista_rem_1[j])>0 )
					j++;	//cerco se c'e' in lista_rem_1
				while ( k<n_songs_rem_2 && lista_server[i].compareTo(lista_rem_2[k])>0 )
					k++;	//cerco se c'e' in lista_rem_2
				if (j==n_songs_rem_1 || k==n_songs_rem_2)	//se una delle liste_rem e' finita ESCI (LE PROSSIME HANNO AL MAX 2 COPIE!)
					break;
				if ( lista_server[i].equals(lista_rem_1[j]) && lista_server[i].equals(lista_rem_2[k]) ) {
					String nome=new String( lista_server[i].substring(0,lista_server[i].length()-2) );
					String nomefile=new String(nome+".txt");
					File old_file=new File(nomefile);
					old_file.delete();	//cancello il testo dal disco del server
					deleted=true;
					}
				if (!deleted)
					temp.write(lista_server[i].getBytes()); //se deve rimanere lo tengo in temp
				deleted=false;
				}// relativo al for
			for (int count=i;count<n_songs;count++)	//eventuale ciclo di completamento
				temp.write(lista_server[count].getBytes());	//DON'T U FORGET!!!
			temp.close();
			File old_file2=new File("lista_server.txt");
		 	old_file2.delete();
		 	File new_file=new File("temp.txt");
	 		new_file.renameTo(new File("lista_server.txt"));
			busy=false;	//fine SEZIONE CRITICA
			cleaner=false;
			notifyAll();
			}//try
		catch (InterruptedException e1) {
			System.out.println(e1);
			}
		catch (IOException e2) {
			System.out.println(e2);
			}
	}//clean_lista_server				

	public int conta_nStrings(String[] vet) {
		for (int i=0;i<100;i++)
			if (vet[i].compareTo("#")==0)
				return i;
		return 0; //se arriva qui non l'ha trovato!
	}//conta_nStrings

}//class MyMonitoredTools