import java.net.*;
import java.io.*;

public class ThreadSvcToClient extends Thread {
MyTools tool;
MyMonitoredTools monitored_tool;
Socket sock_client;
String serv_1;
String serv_2;
String new_line;

	public ThreadSvcToClient(MyTools t1,MyMonitoredTools t2,Socket s,String s1,String s2,String nline) { //costruttore
	 	tool=t1;
		monitored_tool=t2;
		sock_client=s;
		serv_1=new String(s1);
		serv_2=new String(s2);
		new_line=new String(nline);
		}
	public void run() {
		System.out.println("\nNuovo cliente: REGISTRAZIONE in corso...");
		Socket sock_rich_1=tool.connetti_server_rem(serv_1);
		Socket sock_rich_2=tool.connetti_server_rem(serv_2);
		String[] lista_client=new String[50];
		lista_client=tool.sockToArray(sock_client);
		int n_songs_client=tool.conta_nStrings(lista_client);

		String[] lista_server=new String[100];
		lista_server=monitored_tool.fileToArray("lista_server.txt");
		int n_songs_server=monitored_tool.conta_new_line("lista_server.txt");

		tool.scrivi(sock_rich_1,"LISTA"); 			//chiedo al server remoto 1 la sua lista
		String[] lista_rem_1=new String[100];
		lista_rem_1=tool.sockToArray(sock_rich_1);//risposta del server remoto 1
		tool.scrivi(sock_rich_2,"LISTA"); 			//chiedo al server remoto 2 la sua lista
		String[] lista_rem_2=new String[100];
		lista_rem_2=tool.sockToArray(sock_rich_2);//risposta del server remoto 2

		for (int i=0;i<n_songs_client;i++) 			//ciclo scorrim lista_client
			if (!tool.xisPresentInArray(lista_client[i],lista_server) &&
					(!tool.xisPresentInArray(lista_client[i],lista_rem_1) || !tool.xisPresentInArray(lista_client[i],lista_rem_2))) {
				String nuovasenza=new String(lista_client[i].substring(0,lista_client[i].length()-2)); //N.B.!N.B.!N.B.!N.B.!N.B.!N.B.!N.B.!N.B.!!
				String filename=new String(nuovasenza+".txt");//ho tolto il "\n" a client[i], viene da un file, ho dovuto usare -2 nel  substring!
				tool.scrivi(sock_client,filename);     
				tool.sockToFile(sock_client,filename);
				System.out.println("uploaded new song:"+nuovasenza);
				monitored_tool.aggiungi_lista_server("lista_server.txt",lista_client[i]);
				}//if
		tool.scrivi(sock_client,"FINE");
		tool.leggi(sock_client);	//giusto per forzare alternanza send/receive di sincronizzazione
		String[] lista_parz=new String[200];
		String[] lista_tot=new String[300];
		lista_parz=tool.listaUnici(lista_server,lista_rem_1);
		lista_tot=tool.listaUnici(lista_parz,lista_rem_2);
		tool.arrayToSock(lista_tot,sock_client); //spedisco al client la lista dell'archivio distribuito
		for (;;) { //SERVIZO CLIENTE
			String str=new String(tool.leggi(sock_client)); //str non ha il new-line
			if (str.indexOf("TESTO")==0) {
				boolean trovato_su_1=false; boolean trovato_su_2=false;
				String testo=new String(str.substring(5,str.length())); //testo non ha il "\n", ne' il ".txt"
				String nomefile=new String(testo+".txt");
				lista_server=monitored_tool.fileToArray("lista_server.txt");
				if (tool.xisPresentInArray(testo,lista_server)) {//Se presente in locale
					tool.scrivi(sock_client,"FOUND");
					tool.fileToSock(nomefile,sock_client);
					}
				else { //se non presente in locale...
					System.out.println("Inoltro richiesta di "+testo+" agli altri server...");
					tool.scrivi(sock_rich_1,"TESTO"+testo);
					tool.scrivi(sock_rich_2,"TESTO"+testo);
					String risp_1=new String(tool.leggi(sock_rich_1));
					String risp_2=new String(tool.leggi(sock_rich_2));
					trovato_su_1=risp_1.equals("FOUND"); trovato_su_2=risp_2.equals("FOUND");
					if (trovato_su_1 && !trovato_su_2) {
						tool.scrivi(sock_rich_1,"DOWNLOAD");
						tool.sockToFile(sock_rich_1,nomefile); //CACHING
						tool.scrivi(sock_client,"FOUND");
						tool.leggi(sock_client); //per alternare send/receive sulla stessa socket
						tool.fileToSock(nomefile,sock_client); //consegna al client
						System.out.println("CACHED "+testo);
						monitored_tool.aggiungi_lista_server("lista_server.txt",testo+new String(new_line));
						}//if
					else if (trovato_su_2 && !trovato_su_1) {
						tool.scrivi(sock_rich_2,"DOWNLOAD");
						tool.sockToFile(sock_rich_2,nomefile); //CACHING
						tool.scrivi(sock_client,"FOUND");
						tool.leggi(sock_client); //per alternare send/receive sulla stessa socket
						tool.fileToSock(nomefile,sock_client); //consegna al client
						System.out.println("CACHED "+testo);
						monitored_tool.aggiungi_lista_server("lista_server.txt",testo+new String(new_line));
						} 
					else if (!trovato_su_1 && !trovato_su_2)
						tool.scrivi(sock_client,"NOT FOUND!");
					else {	//se trovato su entrambe lo chiedo al server remoto 1, NO CACHING!
						tool.scrivi(sock_rich_1,"DOWNLOAD");
						tool.scrivi(sock_client,"FOUND");
						tool.leggi(sock_client); //per alternare send/receive sulla stessa socket
						tool.sockToSock(sock_rich_1,sock_client); //NO CACHING!!!
						tool.scrivi(sock_rich_2,"NO DLOAD");
						}	//relativo a else se trovato su entrambe (NO CACHING)
					}// relativo a "else (se non presente in locale)"
				}//relativo a "if cliente chiede un TESTO"
			else if (str.indexOf("ARCHIVIO")==0) {
				lista_server=monitored_tool.fileToArray("lista_server.txt");
				tool.scrivi(sock_rich_1,"LISTA");
				lista_rem_1=new String[100];
				lista_rem_1=tool.sockToArray(sock_rich_1);
				tool.scrivi(sock_rich_2,"LISTA");
				lista_rem_2=new String[100];
				lista_rem_2=tool.sockToArray(sock_rich_2);
				lista_parz=tool.listaUnici(lista_server,lista_rem_1);
				lista_tot=tool.listaUnici(lista_parz,lista_rem_2);
				tool.arrayToSock(lista_tot,sock_client);
				}
			else if (str.indexOf("DISCONNECTED")==0) {
				tool.scrivi(sock_rich_1,"DISCONNECTED"); //fa terminare il thread SvcServer sul server rem 1
				tool.scrivi(sock_rich_2,"DISCONNECTED"); //fa terminare il thread SvcServer sul server rem 2
				break; //N.B. la close di sock_client andrebbe fatta nel thread RecClient
				}      //ma non la faccio io, ci pensa il GARBAGE COLLECTOR (vedi codice)
			}//fine del for(;;) SERVIZIO CLIENTE
	} //run
} //class
/* Il thread di registrazione ha una foto delle tabelle al momento in cui e' partito e non
puo' ovviamente tenere conto degli upload che altri client nel frattempo stanno facendo con
altri thread di registazione.
Per questo il metodo aggiungi_lista_server prevede anche il caso in cui l'aggiunta non sia
da fare perche' gia' registrata ad opera di un altro thread di registrazione che nel frattempo
ha agito.

Atro caso particolare piu' complesso e' quello in cui per una qualsiasi delle azioni svolte
dai vari thread ci si puo' ritrovare alla fine con un testo presente su tutti e 3 i nodi.
Ad esempio se piu' clienti con una stessa canzone non ancora in archivio se connettono ai 3
server contemporaneamente.

Siccome non voglio forzare sincronizzazioni tra i thread di registrazione adotto una soluzione
direi a meta' tra l'ottimista e il pessimista: mando in esecuzione un thread cleaner su un nodo
solo, che blocca la lista_server di quel nodo e la ripulisce da eventuali copie triple.
Dopo l'azione il thread si blocca per un fissato periodo di tempo (la soluzione e' ottimista
in questo senso, cioe' che durante quel periodo non si cura del problema) poi la prossima volta
il thread cleaner e' risvegliato sul secondo nodo, poi sul terzo, poi daccapo.
*/